--==================================
--                  Custom Functions
--==================================
function GetTotalRange(equipmentGrid)
	local totalRange = false
	for index = 1, table.maxn(equipmentGrid.equipment) 
	do
		
		--Check equipment for roboport
		if (equipmentGrid.equipment[index].name == "personal-roboport-equipment") then
			--Add to robocount
			if (totalRange == false) then
				totalRange = 30
			else
				totalRange = totalRange + 30
			end
		end
		
		--Check equipment for roboport R10
		if (equipmentGrid.equipment[index].name == "personal-roboport-equipment-R10") then
			--Add to robocount
			if (totalRange == false) then
				totalRange = 10
			else
				totalRange = totalRange + 10
			end
		end
		
		--Check equipment for roboport R20
		if (equipmentGrid.equipment[index].name == "personal-roboport-equipment-R20") then
			--Add to robocount
			if (totalRange == false) then
				totalRange = 20
			else
				totalRange = totalRange + 20
			end
			
		end
		
		--Check equipment for roboport mk2 
		if (equipmentGrid.equipment[index].name == "personal-roboport-mk2-equipment") then
			--Add to robocount
			if (totalRange == false) then
				totalRange = 40
			else
				totalRange = totalRange + 40
			end
		end
		
				--Check equipment for roboport mk2 R10
		if (equipmentGrid.equipment[index].name == "personal-roboport-mk2-equipment-R10") then
			--Add to robocount
			if (totalRange == false) then
				totalRange = 10
			else
				totalRange = totalRange + 10
			end
		end
		
				--Check equipment for roboport mk2 R20
		if (equipmentGrid.equipment[index].name == "personal-roboport-mk2-equipment-R20") then
			--Add to robocount
			if (totalRange == false) then
				totalRange = 20
			else
				totalRange = totalRange + 20
			end
		end
		
				--Check equipment for roboport mk2 R30
		if (equipmentGrid.equipment[index].name == "personal-roboport-mk2-equipment-R30") then
			--Add to robocount
			if (totalRange == false) then
				totalRange = 30
			else
				totalRange = totalRange + 30
			end
		end
		
	end
	
	if not (totalRange == false) then
		return totalRange
	else
		return 0
	end
	
end

function GetMaxRange(equipmentGrid)
	local equipment = equipmentGrid.equipment
	local totalRange = 0

	for index = 1, table.maxn(equipment)
	do
		if not (string.find(equipment[index].name, "roboport") == nil) then
			if not (string.find(equipment[index].name, "mk2") == nil) then
				totalRange = totalRange + 40
			else
				totalRange = totalRange + 30
			end--end if
		end--end if
	end--end for
	
	return totalRange
end

local function IsAdjusted(armor)
	
	if (GetTotalRange(armor) == global.RequestedRange.current) then 
		return true
	else
		return false 
	end

end

local function GetRoboportRangeCode(roboportName)
	if (roboportName == "personal-roboport-equipment-R0") then
		return 100
	elseif (roboportName == "personal-roboport-equipment-R10") then
		return 110
	elseif (roboportName == "personal-roboport-equipment-R20") then
		return 120
	elseif (roboportName == "personal-roboport-equipment") then 
		return 130
	elseif (roboportName == "personal-roboport-mk2-equipment-R0") then
		return 200
	elseif (roboportName == "personal-roboport-mk2-equipment-R10") then
		return 210
	elseif (roboportName == "personal-roboport-mk2-equipment-R20") then
		return 220
	elseif (roboportName == "personal-roboport-mk2-equipment-R30") then
		return 230
	elseif (roboportName == "personal-roboport-mk2-equipment") then
		return 240
	else
		return nil
	end
end

local function GetRoboportNameFromRangeCode(roboportName)
	if (roboportName == 100) then
		return "personal-roboport-equipment-R0"
	elseif (roboportName == 110) then
		return "personal-roboport-equipment-R10"
	elseif (roboportName == 120) then
		return "personal-roboport-equipment-R20"
	elseif (roboportName == 130) then 
		return "personal-roboport-equipment"
	elseif (roboportName == 200) then
		return "personal-roboport-mk2-equipment-R0"
	elseif (roboportName == 210) then
		return "personal-roboport-mk2-equipment-R10"
	elseif (roboportName == 220) then
		return "personal-roboport-mk2-equipment-R20"
	elseif (roboportName == 230) then
		return "personal-roboport-mk2-equipment-R30"
	elseif (roboportName == 240) then
		return "personal-roboport-mk2-equipment"
	else
		return nil
	end
end

local function swapRoboport(armorGrid, newRoboport)
	--newRoboport contains the name of the new roboport and the
	--position of the roboport to be removed. The position is also
	--the position to place the new roboport
	local setRoboEnergy = armorGrid.get(newRoboport.position).energy
	armorGrid.take{position=newRoboport.position}
	armorGrid.put(newRoboport)
	armorGrid.get(newRoboport.position).energy = setRoboEnergy
end

local function GetSmallerRoboport(name)
	
	if (GetRoboportRangeCode(name) == nil) then
		return nil
	else
		return GetRoboportNameFromRangeCode(GetRoboportRangeCode(name) - 10)
	end
	
end

local function GetLargerRoboport(name)

	if (GetRoboportRangeCode(name) == nil) then
		return nil
	else
		return GetRoboportNameFromRangeCode(GetRoboportRangeCode(name) + 10)
	end
	
end

--Directly changes the table data rather than returning the value
local function AdjustRoboportName(armor, namePosition)
	--Check is we are increase the roboport range or decreasing it
	if (GetTotalRange(armor) < global.RequestedRange.current) then
		--increase the roboport range
		namePosition.name =  GetLargerRoboport(namePosition.name)
	else
		--decrease the roboport range
		namePosition.name = GetSmallerRoboport(namePosition.name)
	end
	
end

function AdjustRoboportRange(equipmentGrid)
	local equipment = equipmentGrid.equipment
	local foundRoboports = {name=false, position=false}
	local listOfCustomRoboports = 0
	local listOfCustomMk2Roboports = 0
	local mk1Finds = 0
	local mk2Finds = 0
	local changeThisRoboport = {name=false, position=false}
	
	if not IsAdjusted(equipmentGrid) then
		--define variable with roboport R0 only when we are adding range
		--define the variable without roboport R0 when we are subtracting range
		--otherwise it will create an infinite loop
		if (GetTotalRange(equipmentGrid) < global.RequestedRange.current) then
				listOfCustomRoboports = {"personal-roboport-equipment-R0", "personal-roboport-equipment-R10", 
												   "personal-roboport-equipment-R20"}							   
				listOfCustomMk2Roboports = {"personal-roboport-mk2-equipment-R0", "personal-roboport-mk2-equipment-R10", 
														 "personal-roboport-mk2-equipment-R20", "personal-roboport-mk2-equipment-R30"}
		else
				listOfCustomRoboports = {"personal-roboport-equipment-R10", "personal-roboport-equipment-R20"}							   
				listOfCustomMk2Roboports = {"personal-roboport-mk2-equipment-R10", "personal-roboport-mk2-equipment-R20", "personal-roboport-mk2-equipment-R30"}
		end--end if
															
		--Looks for the custom mk2 roboports first
		for index = 1, table.maxn(equipment) do
			
			--Match the equipment name against a list of custom mk2 roboports
			for subIndex = 1, table.maxn(listOfCustomMk2Roboports) do
				if (equipment[index].name == listOfCustomMk2Roboports[subIndex]) then
					mk2Finds = mk2Finds + 1
					foundRoboports[mk2Finds] = {name=equipment[index].name, position=equipment[index].position}
				end--end if
			end--end for
		end--end for

		--Always change the mk2 armors first
		if (mk2Finds == 0) then
	        --Looks for the custom mk1 roboports
		    for index = 1, table.maxn(equipment) do
		    	
		    	--Match the equipment name against a list of custom mk1 roboports
		    	for subIndex = 1, table.maxn(listOfCustomRoboports) do
		    		if (equipment[index].name == listOfCustomRoboports[subIndex]) then
		    			mk1Finds = mk1Finds + 1
		    			foundRoboports[mk1Finds] = {name=equipment[index].name, position=equipment[index].position}
		    		end --end if
		    	end--end for
		    end--end for
			
			if (mk1Finds > 0) then
			    --Find the smallest mk1 roboport
			    for index = 1, mk1Finds do
			    	if (changeThisRoboport.name == false) then 
			    		changeThisRoboport.name = foundRoboports[index].name
			    		changeThisRoboport.position = foundRoboports[index].position
			    	elseif (GetRoboportRangeCode(changeThisRoboport.name) > GetRoboportRangeCode(foundRoboports[index].name)) then
			    		changeThisRoboport.name = foundRoboports[index].name
			    		changeThisRoboport.position = foundRoboports[index].position
			    	end--end if
			    end--end for
			end--end if
			
	else
			--Find the smallest mk2 roboport
			for index = 1, mk2Finds do
				if (changeThisRoboport.name == false) then 
					changeThisRoboport.name = foundRoboports[index].name
					changeThisRoboport.position = foundRoboports[index].position
				elseif (GetRoboportRangeCode(changeThisRoboport.name) > GetRoboportRangeCode(foundRoboports[index].name)) then
					changeThisRoboport.name = foundRoboports[index].name
					changeThisRoboport.position = foundRoboports[index].position
				end--end if
			end--end for
			
		end--end if
		
		if (mk1Finds == 0 and mk2Finds == 0) then
		    --Looks for the vanilla mk2 roboports first
		    for index = 1, table.maxn(equipment) do
		    	--find mk2 roboport
		    	if (equipment[index].name == "personal-roboport-mk2-equipment") then
		    		--At his point there is no custom roboports; doesn't matter which mk2 robot port
					--abort the loop and use this one
		    		changeThisRoboport = {name=equipment[index].name, position=equipment[index].position}
					break
		    	end--end if
		    end--end for
			
			--if no vanilla mk2 roboports are found then check for vanilla mk1 roboports
		if (changeThisRoboport.name == false) then
		    for index = 1, table.maxn(equipment) do
		       	--find mk1 roboport
		       	if (equipment[index].name == "personal-roboport-equipment") then
		       		--At his point there is no custom roboports; doesn't matter which mk1 robotport
		    		--abort the loop and use this one
		       		changeThisRoboport = {name=equipment[index].name, position=equipment[index].position}
					break
		       	end--end if
		       end--end for
			end--end if
		
		end--end if
		
		--makes sure that a roboport was found before continuing
		if not (changeThisRoboport.name) then
			return false
		end
		
		--Keep getting smaller port till total global.RequestedRange.current matches in the armor
		while (GetTotalRange(equipmentGrid) ~= global.RequestedRange.current) do
			--Adjust the roboport for increasing the range or decreasing the range
			--accomplished by changing the name of the changeThisRoboport
			AdjustRoboportName(equipmentGrid, changeThisRoboport)
			
			if not (changeThisRoboport.name == nil) then
				--swap the roboports in armor inventory
				swapRoboport(equipmentGrid, changeThisRoboport)
			end--end if
			
			--when range of the smaller roboport is 0 find a different roboport to adjust
			if (GetRoboportRangeCode(changeThisRoboport.name) == 100 or 
				 GetRoboportRangeCode(changeThisRoboport.name) == 200) then
				 
				 AdjustRoboportRange(equipmentGrid)
			--when range of the larger roboport is maxed find a different roboport to adjust
			elseif (GetRoboportRangeCode(changeThisRoboport.name) == 130 or 
						GetRoboportRangeCode(changeThisRoboport.name) == 240) then
				 
				 AdjustRoboportRange(equipmentGrid)
			end--end if
			
		end--end while
		
		--final check to see if equipmentGrid was proper adjusted to global.RequestedRange.current
		if (GetTotalRange(equipmentGrid) == global.RequestedRange.current) then
			return true
		else
			return false
		end
	end--end if
end

function UndoAdjustRoboportRange(equipmentGrid)
	local pData = game.players[1]
	local equipment = equipmentGrid.equipment
	
	local listOfCustomRoboports = {"personal-roboport-equipment-R0", "personal-roboport-equipment-R10", 
											   "personal-roboport-equipment-R20"}							   
	local listOfCustomMk2Roboports = {"personal-roboport-mk2-equipment-R0", "personal-roboport-mk2-equipment-R10", 
													"personal-roboport-mk2-equipment-R20", "personal-roboport-mk2-equipment-R30"}
	
	--first replace all of the custom mk2 roboports
	for index = 1, table.maxn(equipment) do
		for subIndex = 1, table.maxn(listOfCustomMk2Roboports) do
			if (equipment[index].name == listOfCustomMk2Roboports[subIndex]) then
				swapRoboport(equipmentGrid, {name="personal-roboport-mk2-equipment", position=equipment[index].position})
				break
			end
		end
	end
	
	--Get new set of equipment after possibly removing custom mk2 roboports
	equipment = equipmentGrid.equipment
	
	--next replace all of the custom mk1 roboports
	for index = 1, table.maxn(equipment) do
		for subIndex = 1, table.maxn(listOfCustomRoboports) do
			if (equipment[index].name == listOfCustomRoboports[subIndex]) then
				swapRoboport(equipmentGrid, {name="personal-roboport-equipment", position=equipment[index].position})
				break
			end
		end
	end
	
end

function CleanCustomRoboports(inventory)
	local listOfCustomRoboports = {"personal-roboport-equipment-R0", "personal-roboport-equipment-R10", 
											   "personal-roboport-equipment-R20"}							   
	local listOfCustomMk2Roboports = {"personal-roboport-mk2-equipment-R0", "personal-roboport-mk2-equipment-R10", 
													"personal-roboport-mk2-equipment-R20", "personal-roboport-mk2-equipment-R30"}
	--Make sure LuaInventory object is valid
	if inventory.valid then 
		for index = 1, table.maxn(listOfCustomMk2Roboports)
		do
			local itemStack = false
			local itemStackIdex = false
			itemStack, itemStackIdex = inventory.find_item_stack(listOfCustomMk2Roboports[index])
			
			if (itemStack) then
				if itemStack.can_set_stack{name="personal-roboport-mk2-equipment", cout=itemStack.count} then
					itemStack.set_stack{name="personal-roboport-mk2-equipment", count=itemStack.count}
				end
			end
			
		end
		
		for index = 1, table.maxn(listOfCustomRoboports)
		do
			local itemStack = false
			local itemStackIdex = false
			itemStack, itemStackIdex = inventory.find_item_stack(listOfCustomRoboports[index])
			
			if (itemStack) then
				if itemStack.can_set_stack{name="personal-roboport-equipment", count=itemStack.count} then
					itemStack.set_stack{name="personal-roboport-equipment", count=itemStack.count}
				end
			end
			
		end
	end
end